<?php

namespace Lean\Console\Controller;

use League\Route\Router;

use Picea\Ui\Method\FormHandler;
use Psr\Http\Message\{ ResponseInterface, ServerRequestInterface };

use Notes\Route\Annotation\Object\Route as RouteParam,
    Notes\Route\Annotation\Method\Route,
    Notes\Security\Annotation\Security,
    Notes\Tell\Annotation\Language;

use \Lean\Console\Lib,
    \Lean\Console\Form;

use Picea\Extension\UrlExtension;

use Ulmus\Annotation\Classes\Table,
    Ulmus\Container\AdapterProxy;


/**
 * @Language("lean.storage")
 */
class Storage extends Console {
    use Lib\ConsoleControllerTrait;

    /**
     * @Route("/storage/database", "name" => "lean.console:request.route")
     * @param ServerRequestInterface $request
     * @param array $arguments
     * @return ResponseInterface
     */
    public function database(ServerRequestInterface $request, array $arguments) : ResponseInterface
    {
        $connections = $this->container->has(AdapterProxy::class) ? $this->container->get(AdapterProxy::class)->connections : false;
        $migrations = $this->container->has(Lib\DatabaseMigrations::class) ? $this->container->get(Lib\DatabaseMigrations::class) : false;
        $migrations->getEntities();

        $form = new FormHandler($request, new Form\Database($migrations), null);
        $context = $form->context;

        return $this->renderView("lean-console/page/storage/database", get_defined_vars());
    }

    public function createTable() : void
    {
        foreach($migrations->entities as $table) {
//            $repository = $table
            // $entity::repository()->createTable();
        }
    }
}